> For the complete documentation index, see [llms.txt](https://docs.mav.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mav.xyz/technical-reference/maverick-v2/v2-contracts/maverick-v2-amm-contracts/maverickv2poolpermissioned.md).

# MaverickV2PoolPermissioned

**Inherits:** [MaverickV2Pool](/technical-reference/maverick-v2/v2-contracts/maverick-v2-amm-contracts/maverickv2pool.md)

### State Variables <a href="#state-variables" id="state-variables"></a>

#### variableFeeAIn <a href="#variablefeeain" id="variablefeeain"></a>

```solidity
uint128 private variableFeeAIn;
```

#### variableFeeBIn <a href="#variablefeebin" id="variablefeebin"></a>

```solidity
uint128 private variableFeeBIn;
```

### Functions <a href="#functions" id="functions"></a>

#### onlyAccessor <a href="#onlyaccessor" id="onlyaccessor"></a>

```solidity
modifier onlyAccessor();
```

#### addLiquidity <a href="#addliquidity" id="addliquidity"></a>

```solidity
function addLiquidity(address user, uint256 subaccount, AddLiquidityParams calldata params, bytes calldata data)
    public
    override
    onlyAccessor
    returns (uint256 tokenAAmount, uint256 tokenBAmount, uint32[] memory binIds);
```

#### migrateBinUpStack <a href="#migratebinupstack" id="migratebinupstack"></a>

```solidity
function migrateBinUpStack(uint32 binId, uint32 maxRecursion) public override onlyAccessor;
```

#### removeLiquidity <a href="#removeliquidity" id="removeliquidity"></a>

```solidity
function removeLiquidity(address recipient, uint256 subaccount, RemoveLiquidityParams calldata params)
    public
    override
    onlyAccessor
    returns (uint256 tokenAOut, uint256 tokenBOut);
```

#### swap <a href="#swap" id="swap"></a>

```solidity
function swap(address recipient, SwapParams memory params, bytes calldata data)
    public
    override
    onlyAccessor
    returns (uint256 amountIn, uint256 amountOut);
```

#### setFee <a href="#setfee" id="setfee"></a>

```solidity
function setFee(uint256 newFeeAIn, uint256 newFeeBIn) public override onlyAccessor;
```

#### fee <a href="#fee" id="fee"></a>

```solidity
function fee(bool tokenAIn) public view override returns (uint256);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mav.xyz/technical-reference/maverick-v2/v2-contracts/maverick-v2-amm-contracts/maverickv2poolpermissioned.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
